# -*- coding: utf-8 -*-

from dataton_constants import *
import pydocumentdb
import pydocumentdb.document_client as document_client
import numpy as np
import matplotlib.pyplot as plt
import pprint
from collections import Counter

## Configure Matplotlib ggplot
plt.style.use("ggplot")

plt.rcParams['font.family'] = 'serif'
plt.rcParams['font.serif'] = 'Ubuntu'
plt.rcParams['font.monospace'] = 'Ubuntu Mono'
plt.rcParams['font.size'] = 5
plt.rcParams['axes.labelsize'] = 16
plt.rcParams['axes.titleweight'] = 'bold'
plt.rcParams['axes.titlesize'] = 14
plt.rcParams['xtick.labelsize'] = 14
plt.rcParams['ytick.labelsize'] = 14
plt.rcParams['legend.fontsize'] = 16
plt.rcParams['figure.titlesize'] = 20

if __name__ == "__main__":
	##########################################################################
	##########################################################################
	## Find some random documents and print them

	## Connect to database
	host =  "https://dataton.documents.azure.com:443/"
	key = "je08NUk7s9faGYP6Vdhg9JejXKHQpl447WDK5YxTBR0wQ568D3hrWgRyPT7n7Kij9e7CqnizJpGFDlfEoEqB9w=="
	client = document_client.DocumentClient(host, {'masterKey': key})

	## Select collection
	collname = "test"
	db = next((data for data in client.ReadDatabases() if data['id'] == "dataton"))
	collection = next((data for data in client.ReadCollections(db["_self"]) if data['id'] == collname))

	## Query some random documents (including first and last)
	q = "SELECT * FROM c"
	res = client.QueryDocuments(collection["_self"],q,{"MaxItemCount":-1})
	for i,t in enumerate(res):
		pprint.pprint(t)
		raw_input("Press ENTER to continue, press ctrl+c to stop")
	##########################################################################
	##########################################################################
	# ## Compute product frequencies

	# ## Connect to database
	# host =  "https://dataton.documents.azure.com:443/"
	# key = "je08NUk7s9faGYP6Vdhg9JejXKHQpl447WDK5YxTBR0wQ568D3hrWgRyPT7n7Kij9e7CqnizJpGFDlfEoEqB9w=="
	# client = document_client.DocumentClient(host, {'masterKey': key})

	# ## Select collection
	# collname = "test"
	# db = next((data for data in client.ReadDatabases() if data['id'] == "dataton"))
	# collection = next((data for data in client.ReadCollections(db["_self"]) if data['id'] == collname))

	# ## Perform query
	# q = "SELECT c.Cod_Prod FROM c"
	# res = client.QueryDocuments(collection["_self"],q,{"MaxItemCount":-1})
	# prods_lst = []
	# for i,prd in enumerate(res):
	# 	if (i+1) % 100 == 0:
	# 		print i
	# 	if i == 100000:
	# 		break
	# 	prods_lst.append(prd["Cod_Prod"])

	# ## Plot results
	# x, y = zip(*sorted(Counter(prods_lst).items(),key=lambda x:x[1],reverse=True))
	# y = np.array(y)
	# y = y/(1.0*y.sum())
	# x = [prod_pos[i] for i in x]
	# print set(range(94)) - set(x)
	# ax = plt.axes()
	# x_final = np.arange(len(y))*3
	# plt.bar(x_final,y,align="center",log=True)
	# for xi,yi in enumerate(y):
	# 	ax.annotate(
	# 		str(pos_prod[x[xi]]), 
	# 		(x_final[xi], yi),
	# 		rotation = 75,
	# 		horizontalalignment='center',
	# 		verticalalignment='bottom',
	# 		fontsize=8)
	# plt.title(u"Probabilidad de contratación de cada producto",y=1.02)
	# plt.xlabel("Productos")
	# plt.ylabel("Probabilidad")
	# plt.xticks(ax.get_xticks(),[])
	# plt.tight_layout()
	# plt.show()
	##########################################################################
	##########################################################################