# -*- coding: utf-8 -*-

import imp
from generate_features_labels import *
from dataton_constants import *

import cPickle
import argparse

def predict_test_save(load_model,load_file,save_path):
	## Build features matrix and labels vectors
	print "Generating customer transactions list..."
	cstm_lst = get_customers_lst(load_file)
	print "Customer list generated"
	print "Building the features matrix..."
	X, custom_pos = build_X_y_from_custom_iter_ch_V3(
		cstm_lst,
		len(cstm_lst),
		train_test = "test",
		add_bag_of_prods = True,
		add_bop_abs_dates = False,
		add_bop_rel_dates = False,
		add_last_prods = 3,
		add_lst_prd_abs_dates = True,
		add_lst_prd_rel_dates = True,
		scale_abs_dates_equal = False,
		scale_rel_dates_equal = False,
		orig_date = datetime.datetime(1950,1,1),
		abs_axis_norm = 0,
		rel_axis_norm = 0,
		rel_alpha = 24*3600,
		debug = False,
	)
	print "Features matrix built"

	## Load model and predict
	print "Loading model..."
	with open(load_model,"rb") as f:
		model = cPickle.load(f)
	print "Model loaded"

	print "Predicting (this will take a while)..."
	y_pred = model.predict(X)
	print "Done"

	## Save prediction
	print "Saving prediction..."
	with open(save_path,"w") as f:
		line = "%s|%s\n"%("ID_Customer", "Cod_Prod")
		f.write(line)
		for cstm, pos in custom_pos.iteritems():
			line = "%s|%04d\n"%(cstm,pos_prod[y_pred[pos]])
			f.write(line)
	print "Prediction saved in %s\nEverything finished!"%save_path

if __name__ == "__main__":
	load_model = "./models/XGBoost_100.p"
	load_file = "./data/test2.txt"
	save_path = "./results/Test_Mission.txt"

	parser = argparse.ArgumentParser(description='Make a prediction.')
	parser.add_argument('--model', type=str,
	                   help='Path of the model file (default: %s)'%load_model,
	                   default=load_model)
	parser.add_argument('--test', type=str,
	                   help='Path of the test file (default: %s)'%load_file,
	                   default=load_file)
	parser.add_argument('--save', type=str,
	                   help='Path to save the prediction (default: %s)'%save_path,
	                   default=save_path)
	args = parser.parse_args()

	load_model = args.model
	load_file = args.test
	save_path = args.save

	predict_test_save(load_model,load_file,save_path)